/* 	PLUGIN_(LOGD)_ALLOWSOUNDS
	WRITTEN BY: [WING] Sir Drink a lot
	VISIT WWW.ADMINMOD.DE
	
	Description: 	Die meisten meiner Plugins benutzen Sounds. Da es aber viele Spieler gibt,
			die diese Sounds nicht hren wollen, knnen sie diese mit der Chateingabe 'stop' oder 
			'stopsound' fr sich abschalten.
			Mit 'play' oder 'playsound' kann man die Sounds fr sich auch wieder aktivieren.
			
			Es wird eine setinfo Zeile beim Spieler in der config.cfg generiert.
			Diese heit: setinfo 'am_sound' '0/1'.
			Steht sie auf 0 werden die Sounds abgespielt. Steht sie auf 1, bekommt er keine Sounds mehr 
			von meinen Plugins vorgespielt.
			
			Es wird den toten Spielern auch alle 3 Min eine Message angezeigt, die darauf hinweit, dass
			sie die sounds abschalten knnen.
			
	Wichtig:	Spieler, die ihre config.cfg schreibgeschtzt haben, mssen den Eintrag manuell vornehmen.
			Hat ein Spieler NIE eine Eingabe gemacht bzw. besitzt diese Setinfo-Zeile nicht in seiner
			config.cfg, werden ihm IMMER sounds abgespielt!
	
*/
			
			 
#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[MAX_DATA_LENGTH] = "29.01.03";

new Key[]="am_sound";

#define ACCESS_CONSOLE 131072

new RepeatMsg[MAX_TEXT_LENGTH];
new ConnectMsg1[MAX_TEXT_LENGTH];
new ConnectMsg0[MAX_TEXT_LENGTH];


/*Diese Funktion ist in allen Plugins von mir enthalten.*/
allowsound(User[]){
	new Info[MAX_NUMBER_LENGTH];
	new iInfo;
	new Authid[MAX_AUTHID_LENGTH];
	get_userAuthID(User,Authid,MAX_AUTHID_LENGTH);
	if(strcmp(Authid,"BOT")!=0){
		get_userinfo(User,Key,Info,MAX_NUMBER_LENGTH);
		iInfo=strtonum(Info);
		if(strlen(Info)==0){/*damit wird automatisch immer der Sound auf 1 gesetzt,wenn kein setinfo vorhanden, bis 'stop' eingegeben wird*/
			return 1;
		}
		if(iInfo>=1){
			return 1;
		}else{
			return 0;
		}
		return 0;
	}
	return 0;
}

/* automatischer Zeilenumbruch (c) by [WING] Black Knight */
strnsplit(str[],first[],second[],n) { 
   new i; 
   new maxlen=strlen(str); 
   new m=n+1; 

   for(i=0; i<=n; i++){ 
      first[i]=str[i]; 
   } 
   first[n+1]=NULL_CHAR; 
   for(i=m;i<=maxlen;i++){ 
      second[i-m]=str[i]; 
   } 
   second[maxlen+1]=NULL_CHAR; 

   return 1; 
} 

umbrechen(sString[],Result[],Laenge){ 
   new erster[MAX_DATA_LENGTH]; 
   new zweiter[MAX_DATA_LENGTH]; 
   new sLaenge,pLaenge; 
   new pos=0; 
   new j=0; 
   new wo=0; 
   new i; 

   strinit(Result); 
   sLaenge=strlen(sString); 
   pLaenge=sLaenge; 
   while(pLaenge > Laenge || j==10){ 
      for(i=pos;i<=pos+Laenge;i++){ 
         if(sString[i]==' '){ 
            wo=i; 
         } 
         else if(sString[i]=='^n'){ 
            wo=i; 
            break; 
         } 
      } 
      sString[wo]='^n'; 
      if(wo==pos){ 
         strnsplit(sString,erster,zweiter,pos+Laenge-1); 
         snprintf(sString,MAX_DATA_LENGTH,"%s^n%s",erster,zweiter); 
         sLaenge++; 
         wo=pos+Laenge; 
      } 
      pos=wo+1; 
      pLaenge=sLaenge-wo; 
      j++; 
   } 
   strcpy(Result,sString,MAX_DATA_LENGTH); 
   return j; 
}

public show_deadrepeatmsg(Timer,Repeat,HLName,HLParam){
	new Name[MAX_NAME_LENGTH];
	new Authid[MAX_AUTHID_LENGTH];
	new sid,wid,team,dead;
	
	new maxplayers=maxplayercount();
	new i;
	
	for(i=1;i<=maxplayers;i++){
		if(playerinfo(i,Name,MAX_NAME_LENGTH,sid,wid,team,dead,Authid)){
			if(strcmp(Authid,"BOT")!=0){
				messageex(Name,RepeatMsg,print_tty);
			}
		}
	}
	return PLUGIN_CONTINUE;
}

public HandleSay(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Msg [MAX_TEXT_LENGTH];
	new SetInfo[MAX_TEXT_LENGTH];
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_DATA_LENGTH);
	strstripquotes(Data);
	
	if(strcasecmp(Data, "stopsound") ==0 || strcasecmp(Data, "stop") ==0){
		snprintf(Msg,MAX_TEXT_LENGTH,"You won`t hear the sounds any longer. Use 'playsound' or 'play' if you want to enable them.");
		messageex(User,Msg,print_chat);
		snprintf(SetInfo,MAX_TEXT_LENGTH,"setinfo ^"%s^" ^"0^"",Key);
		execclient(User,SetInfo);
        }else if(strcasecmp(Data, "playsound") ==0 || strcasecmp(Data, "play") ==0){
		snprintf(Msg,MAX_TEXT_LENGTH,"You have enabled the sounds. Use 'stopsound' or 'stop' if you want to turn them off.");
		messageex(User,Msg,print_chat);
		snprintf(SetInfo,MAX_TEXT_LENGTH,"setinfo ^"%s^" ^"1^"",Key);
		execclient(User,SetInfo);
	}
	return PLUGIN_CONTINUE;
}


public allowsound_connect(HLCommand,HLUserIndex){
	new UserIndex;
	new strUserIndex[MAX_NAME_LENGTH];
	new strName[MAX_NAME_LENGTH];
	new dummy;
	convert_string(HLUserIndex, strUserIndex, MAX_NAME_LENGTH);
	UserIndex=strtonum(strUserIndex);
	playerinfo(UserIndex,strName,MAX_NAME_LENGTH,dummy,dummy,dummy,dummy);
	if(allowsound(strName)){
		messageex(strName,ConnectMsg1,print_tty);
	}else{
		messageex(strName,ConnectMsg0,print_tty);
	}
	return PLUGIN_CONTINUE;
}
				
public plugin_init() {
	plugin_registerinfo("SDAL ALLOWSOUND","Clients can decide, if they want hear custom sounds",STRING_VERSION);
	plugin_registercmd("allowsound_connect","allowsound_connect",ACCESS_CONSOLE);
	plugin_registercmd("say","HandleSay",ACCESS_ALL);
	plugin_registerhelp("say",ACCESS_ALL,"say 'stop' or 'stopsound': disables all custom sounds for you");
	plugin_registerhelp("say",ACCESS_ALL,"say 'play' or 'playsound': enables all custom sounds for you");
	
	exec( "logd_reg 51 admin_command allowsound_connect" );		/*ENTER-EVENT*/
	
	new repeatstatus;
	new repeattime;
	new msg[MAX_TEXT_LENGTH];
	new connectmsg1[MAX_TEXT_LENGTH];
	new connectmsg0[MAX_TEXT_LENGTH];
	
	get_vaultnumdata("ALLOWSOUND_REPEATSTATUS",repeatstatus);
	get_vaultnumdata("ALLOWSOUND_REPEATTIME",repeattime);
	get_vaultdata("ALLOWSOUND_REPEATMSG",msg,MAX_TEXT_LENGTH);
	get_vaultdata("ALLOWSOUND_CONNECTMSG1",connectmsg1,MAX_TEXT_LENGTH);
	get_vaultdata("ALLOWSOUND_CONNECTMSG0",connectmsg0,MAX_TEXT_LENGTH);
	
	umbrechen(connectmsg1,ConnectMsg1,50);
	umbrechen(connectmsg0,ConnectMsg0,50);	
	
	if(repeatstatus==1){
		umbrechen(msg,RepeatMsg,50);
		set_timer("show_deadrepeatmsg",repeattime,99999);
	}
	return PLUGIN_CONTINUE;
}
	